/*
 * Simson's XML output class.
 */

#include <string>
#include <stdio.h>
#include "tagset.h"

using namespace std;

class xml {
    string outfilename;
    FILE  *out;				// where it is being written
    tagset tags;
    tagset file_tags;
    void  write_doctype(FILE *out);
    void  write_dtd(FILE *out);
    bool  make_dtd;
    char  tempfilename[64];
    void  verify_tag(const string &tag);

public:
    xml();				// private constructor

    void set_outFILE(FILE *out);	  // writes to this FILE without a DTD
    void set_outfilename(string outfilename);     // writes to this outfile with a DTD (needs a temp file)
    void set_makeDTD(bool flag);		 // should we write the DTD?

    static string xmlescape(const string &xml);
    static string xmlstrip(const string &xml);
    
    //FILE *file(){return out;}
    void open();			// opens the output file
    void close();			// writes the output to the file
    void xmlout(const string &tag,const string &value,const string &attribute,const bool quote);
    void push(const string &tag,const string &attribute);
    void push(const string &tag) {push(tag,"");fputc('\n',out);}
    void puts(const string &pdata);	// writes a string as parsed data
    void printf(const char *fmt,...);	// writes a string as parsed data
    void pop(const string &tag);	// close the tag
    void comment(const string &comment);
};
